/**
 * @file AE3ComProject.cpp
 * @brief Legt die Initialisierungsroutinen fuer die DLL fest.
 */
//////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "AE3ComProject.h"
#include "AE3Com.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Beachten Sie!
//
//		Wird diese DLL dynamisch an die MFC-DLLs gebunden,
//		muss bei allen von dieser DLL exportierten Funktionen,
//		die MFC-Aufrufe durchfhren, das Makro AFX_MANAGE_STATE
//		direkt am Beginn der Funktion eingefgt sein.
//
//		Beispiel:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//		// Hier normaler Funktionsrumpf
//		}
//
//		Es ist sehr wichtig, dass dieses Makro in jeder Funktion
//		vor allen MFC-Aufrufen erscheint. Dies bedeutet, dass es
//		als erste Anweisung innerhalb der Funktion ausgefhrt werden
//		muss, sogar vor jeglichen Deklarationen von Objektvariablen,
//		da ihre Konstruktoren Aufrufe in die MFC-DLL generieren
//		knnten.
//
//		Siehe MFC Technical Notes 33 und 58 fr weitere
//		Details.
//

/////////////////////////////////////////////////////////////////////////////
// CAE3ComProjectApp

#ifdef _WIN32
BEGIN_MESSAGE_MAP(CAE3ComProjectApp, CWinApp)
	//{{AFX_MSG_MAP(CAE3ComProjectApp)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif

/////////////////////////////////////////////////////////////////////////////
// CAE3ComProjectApp Konstruktion

CAE3ComProjectApp::CAE3ComProjectApp()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen
	// Alle wichtigen Initialisierungen in InitInstance platzieren

}

/////////////////////////////////////////////////////////////////////////////
// CAE3ComProjectApp Members
#ifdef _WIN32
/**
 * @brief Initialisieren der Anwendung.
 */
BOOL CAE3ComProjectApp::InitInstance() 
{
	// Benutzung der Socket - Funktionalitaet initialisieren
	WSADATA WindowsData;
	WORD    Version;

	Version = MAKEWORD(2, 2);
	WSAStartup(Version, &WindowsData);

	return CWinApp::InitInstance();
}
#endif

#ifdef _WIN32
/**
 * @brief Anwendung auf beenden vorbereiten.
 */
int CAE3ComProjectApp::ExitInstance() 
{
	// Socket - Funktionalitaet exit
	WSACleanup();

	return CWinApp::ExitInstance();
}
#endif

/**
 * @brief Sicherstellen das die Anfrage und das Kanalobjekt in Ordnung ist.
 */
bool CAE3ComProjectApp::ChannelRequest(int iChannelNum)
{
	// Kanalbereich pruefen und evntl. erstellen des nicht vorhandenen Kanalobjektes.
	if (iChannelNum < 0 || iChannelNum >= MAX_CHANNEL) {
		
		// Bereich falsch
		return false;
	}

	// Kanalobjekt bereits vorhanden?
	if (m_channelArray[iChannelNum] != NULL) {
	
		return true;
	}

	// Kanalobjekt erzeugen
	m_channelArray[iChannelNum] = new CAE3Channel((unsigned char)iChannelNum);

	return true;
}

/**
 * @brief Erhalt eines Kanalobjekts oder NULL bei Bereichsueberschreitung sowie Fehler.
 */
CAE3Channel *CAE3ComProjectApp::GetChannel(int iNum)
{
	if (ChannelRequest(iNum)) {
		
		return m_channelArray[iNum];
	}

	return NULL;
}

/////////////////////////////////////////////////////////////////////////////
// Das einzige CAE3ComProjectApp-Objekt

CAE3ComProjectApp theApp;

