/**
 * @file  AE3ComProject.h
 * @brief Haupt-Header-Datei fuer die DLL AE3ComProject.
 */
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AE3COMPROJECT_H__9C5686AB_BB8E_4574_9C30_58A46A1A47AB__INCLUDED_)
#define AFX_AE3COMPROJECT_H__9C5686AB_BB8E_4574_9C30_58A46A1A47AB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef _WIN32
#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// Hauptsymbole
#endif

// Kommunikationsarray fuer Verbindungen
#include "AE3ChannelArray.h"
// Logobjekt
#include "DFLog.h"

/////////////////////////////////////////////////////////////////////////////
// CAE3ComProjectApp
// Siehe AE3ComProject.cpp fr die Implementierung dieser Klasse
//

/// Anwendungsobjekt.
#ifdef _WIN32
class CAE3ComProjectApp : public CWinApp
#else
class CAE3ComProjectApp
#endif
{
public:
	/// Konstruktor
	CAE3ComProjectApp();

#ifdef _WIN32
// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAE3ComProjectApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CAE3ComProjectApp)
		// HINWEIS - An dieser Stelle werden Member-Funktionen vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
#endif

// Helper
public:
	/// Anfrage an Kanalarray stellen.
	bool ChannelRequest(int iChannelNum);
	/// Ermitteln der Kanalklasse aus Array.
	CAE3Channel *GetChannel(int iNum);

// Membervars
protected:
	/// Arrayobjekt fuer Kanalklassen.
	CAE3ChannelArray m_channelArray;
public:
	/// Logobjekt
	DFLog m_log;
};

/////////////////////////////////////////////////////////////////////////////
extern CAE3ComProjectApp theApp;

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_AE3COMPROJECT_H__9C5686AB_BB8E_4574_9C30_58A46A1A47AB__INCLUDED_)

