#include "StdAfx.h"
#include "DFFileDefaultValue.h"

CDFFileDefaultValue::CDFFileDefaultValue()
{
	// Standard voreinstellen
	Reset();
}

CDFFileDefaultValue::~CDFFileDefaultValue()
{
}

void CDFFileDefaultValue::Reset()
{
	// Fehlerobjekt zuruecksetzten
	m_errorState = ES_NO;

	// Reset der Struktur
	memset((void*)&m_mc35i, 0, sizeof(SMODEM_MC35i));
}

INT32 CDFFileDefaultValue::Load(INT8 *fileName) 
{
	// Lesen der Inidatei
	FILE *fp;
	INT8 data[0x400];
	UINT8 i;

	if ((fp = fopen(fileName, "r")) == (FILE*)0) {
		// Oeffnen der Datei gescheitert
		m_errorState = ES_FILE_OPEN;
		return FALSE;
	}

	// Fehlerobjekt zuruecksetzten
	m_errorState = ES_NO;

	if (!GetString("MODEM_MC35i", "PHONE", data, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}
	// 24 Zeichen 
	if (strlen(data) < 24) {
	
		strcpy(m_mc35i.PHONE, data);
	} else {

		m_errorState = ES_INI_KEY_VALUE;
		goto label_fail;
	}

	if (!GetString("MODEM_MC35i", "GPRS", data, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}
	// 50 Zeichen
	if (strlen(data) < 50) {
	
		strcpy(m_mc35i.GPRS, data);
	} else {

		m_errorState = ES_INI_KEY_VALUE;
		goto label_fail;
	}
/*
	if (!GetString("MODEM_MC35i", "PIN", data, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}
	// 20 Zeichen (nur Ziffern)
	if (strlen(data) < 20) {

		for (i=0; i < strlen(data); i++) {
			if (!isdigit(data[i])) {

				m_errorState = ES_INI_KEY_VALUE;
				goto label_fail;
			}
		}
		strcpy(m_mc35i.PIN, data);
	} else {

		m_errorState = ES_INI_KEY_VALUE;
		goto label_fail;
	}
*/
	if (!GetString("MODEM_MC35i", "USER", data, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}
	// 21 Zeichen
	if (strlen(data) < 21) {
	
		strcpy(m_mc35i.USER, data);
	} else {

		m_errorState = ES_INI_KEY_VALUE;
		goto label_fail;
	}


	if (!GetString("MODEM_MC35i", "PASSWORD", data, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}
	// 21 Zeichen
	if (strlen(data) < 21) {

		strcpy(m_mc35i.PASSWORD, data);
	} else {

		m_errorState = ES_INI_KEY_VALUE;
		goto label_fail;
	}

	if (!GetString("MODEM_MC35i", "HOST", data, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}
	// 50 Zeichen
	if (strlen(data) < 50) {
	
		strcpy(m_mc35i.HOST, data);
	} else {

		m_errorState = ES_INI_KEY_VALUE;
		goto label_fail;
	}


	if (!GetString("MODEM_MC35i", "PORT", data, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}
	// 6 Zeichen (nur Ziffern)
	if (strlen(data) < 6) {
		for (i=0; i < strlen(data); i++) {
			if (!isdigit(data[i])) {

				m_errorState = ES_INI_KEY_VALUE;
				goto label_fail;
			}
		}
		strcpy(m_mc35i.PORT, data);
	} else {

		m_errorState = ES_INI_KEY_VALUE;
		goto label_fail;
	}


	if (!GetString("MODEM_MC35i", "HTTPSEND", data, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}
	// 40 Zeichen
	if (strlen(data) < 40) {
	
		strcpy(m_mc35i.HTTPSEND, data);
	} else {

		m_errorState = ES_INI_KEY_VALUE;
		goto label_fail;
	}

	strcpy(m_mc35i.ALIVE, "0");
#ifdef _WIN32
	if (GetPrivateProfileString("MODEM_MC35i", "ALIVE", "0", data, 5, fileName)) {

		strcpy(m_mc35i.ALIVE, data);
	}
#endif

label_fail:
	fclose(fp);	

	return (m_errorState == ES_NO);
}

INT32 CDFFileDefaultValue::Save(INT8 *fileName) 
{
	// Fehlerobjekt zuruecksetzten
	m_errorState = ES_NO;

	if (!Scan("MODEM_MC35i", "PHONE", m_mc35i.PHONE, SF_WRITE | SF_CREATE, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}

	if (!Scan("MODEM_MC35i", "GPRS", m_mc35i.GPRS, SF_WRITE | SF_CREATE, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}
/*
	if (!Scan("MODEM_MC35i", "PIN", m_mc35i.PIN, SF_WRITE | SF_CREATE, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}
*/
	if (!Scan("MODEM_MC35i", "USER", m_mc35i.USER, SF_WRITE | SF_CREATE, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}

	if (!Scan("MODEM_MC35i", "PASSWORD", m_mc35i.PASSWORD, SF_WRITE | SF_CREATE, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}

	if (!Scan("MODEM_MC35i", "HOST", m_mc35i.HOST, SF_WRITE | SF_CREATE, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}

	if (!Scan("MODEM_MC35i", "PORT", m_mc35i.PORT, SF_WRITE | SF_CREATE, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}

	if (!Scan("MODEM_MC35i", "HTTPSEND", m_mc35i.HTTPSEND, SF_WRITE | SF_CREATE, fileName)) {
		m_errorState = ES_INI_KEY;
		goto label_fail;
	}

label_fail:
	return (m_errorState == ES_NO);
}

INT32 CDFFileDefaultValue::LoadWin32(INT8 *fileName) 
{
	// Lesen der Inidatei
	UINT32 val;

	// Fehlerobjekt zuruecksetzten
	m_errorState = ES_NO;

	GetPrivateProfileString("MODEM_MC35i", "PHONE", "*99#", m_mc35i.PHONE, sizeof(m_mc35i.PHONE), fileName);
	GetPrivateProfileString("MODEM_MC35i", "GPRS", "internet.t-mobile", m_mc35i.GPRS, sizeof(m_mc35i.GPRS), fileName);
	GetPrivateProfileString("MODEM_MC35i", "USER", "td1", m_mc35i.USER, sizeof(m_mc35i.USER), fileName);
	GetPrivateProfileString("MODEM_MC35i", "PASSWORD", "gprs", m_mc35i.PASSWORD, sizeof(m_mc35i.PASSWORD), fileName);
	GetPrivateProfileString("MODEM_MC35i", "HOST", "www.datafox.de", m_mc35i.HOST, sizeof(m_mc35i.HOST), fileName);

	if (val = GetPrivateProfileInt("MODEM_MC35i", "PORT", 80, fileName)) {

		if ((val > 0) && (val < 65536)) {

			sprintf(m_mc35i.PORT, "%u", val);
		} else {

			m_errorState = ES_INI_KEY;
		}

	}

	GetPrivateProfileString("MODEM_MC35i", "HTTPSEND", "GET /oem/gprs/getdata.php?", m_mc35i.HTTPSEND, sizeof(m_mc35i.HTTPSEND), fileName);

	strcpy(m_mc35i.ALIVE, "0");
	if (val = GetPrivateProfileInt("MODEM_MC35i", "ALIVE", 0, fileName)) {

		// zwischen 1min und 18h
		if ((val > 59) && (val < 65500)) {

			sprintf(m_mc35i.ALIVE, "%u", val);
		} else {

			m_errorState = ES_INI_KEY;
		}
	}

	strcpy(m_mc35i.HTTPTIMEOUT, "10000");
	if (val = GetPrivateProfileInt("MODEM_MC35i", "HTTPTIMEOUT", 0, fileName)) {

		// zwischen 5sec und 65sec
		if ((val > 5000) && (val < 65000)) {

			sprintf(m_mc35i.HTTPTIMEOUT, "%u", val);
		} else {

			m_errorState = ES_INI_KEY;
		}
	}

	GetPrivateProfileString("MODEM_MC35i", "HTTPTYPE", "1.1", m_mc35i.HTTPTYPE, sizeof(m_mc35i.HTTPTYPE), fileName);
	if (!((m_mc35i.HTTPTYPE[0] == '1') && (m_mc35i.HTTPTYPE[1] == '.') && (m_mc35i.HTTPTYPE[2] == '1')) &&
		!((m_mc35i.HTTPTYPE[0] == '1') && (m_mc35i.HTTPTYPE[1] == '.') && (m_mc35i.HTTPTYPE[2] == '0')) &&
		!((m_mc35i.HTTPTYPE[0] == 'o') && (m_mc35i.HTTPTYPE[1] == 'f') && (m_mc35i.HTTPTYPE[2] == 'f')) ) {

		strcpy(m_mc35i.HTTPTYPE, "1.1");
	}

	return (m_errorState == ES_NO);
}

INT32 CDFFileDefaultValue::SaveWin32(INT8 *fileName) 
{
	// Fehlerobjekt zuruecksetzten
	m_errorState = ES_NO;

	if (!WritePrivateProfileString("MODEM_MC35i", "PHONE", m_mc35i.PHONE, fileName)) {
		m_errorState = ES_INI_KEY;
	}

	if (!WritePrivateProfileString("MODEM_MC35i", "GPRS", m_mc35i.GPRS, fileName)) {
		m_errorState = ES_INI_KEY;
	}

	if (!WritePrivateProfileString("MODEM_MC35i", "USER", m_mc35i.USER, fileName)) {
		m_errorState = ES_INI_KEY;
	}

	if (!WritePrivateProfileString("MODEM_MC35i", "PASSWORD", m_mc35i.PASSWORD, fileName)) {
		m_errorState = ES_INI_KEY;
	}

	if (!WritePrivateProfileString("MODEM_MC35i", "HOST", m_mc35i.HOST, fileName)) {
		m_errorState = ES_INI_KEY;
	}

	if (!WritePrivateProfileString("MODEM_MC35i", "PORT", m_mc35i.PORT, fileName)) {
		m_errorState = ES_INI_KEY;
	}

	if (!WritePrivateProfileString("MODEM_MC35i", "HTTPSEND", m_mc35i.HTTPSEND, fileName)) {
		m_errorState = ES_INI_KEY;
	}

	if (!WritePrivateProfileString("MODEM_MC35i", "ALIVE", m_mc35i.ALIVE, fileName)) {
		m_errorState = ES_INI_KEY;
	}

	if (!WritePrivateProfileString("MODEM_MC35i", "HTTPTIMEOUT", m_mc35i.HTTPTIMEOUT, fileName)) {
		m_errorState = ES_INI_KEY;
	}

	if (!WritePrivateProfileString("MODEM_MC35i", "HTTPTYPE", m_mc35i.HTTPTYPE, fileName)) {
		m_errorState = ES_INI_KEY;
	}

	return (m_errorState == ES_NO);
}

INT32 CDFFileDefaultValue::Show() 
{
	CString strMsg, str;
	str.Format("PHONE: %s\n", m_mc35i.PHONE);
	strMsg = str;
	str.Format("GPRS: %s\n", m_mc35i.GPRS);
	strMsg += str;
//	str.Format("PIN: %s\n", m_mc35i.PIN);
//	strMsg += str;
	str.Format("USER: %s\n", m_mc35i.USER);
	strMsg += str;
	str.Format("PASSWORD: %s\n", m_mc35i.PASSWORD);
	strMsg += str;
	str.Format("HOST: %s\n", m_mc35i.HOST);
	strMsg += str;
	str.Format("PORT: %s\n", m_mc35i.PORT);
	strMsg += str;
	str.Format("HTTPSEND: %s", m_mc35i.HTTPSEND);
	strMsg += str;
	str.Format("ALIVE: %s", m_mc35i.ALIVE);
	strMsg += str;
	str.Format("HTTPTIMEOUT: %s", m_mc35i.HTTPTIMEOUT);
	strMsg += str;

	AfxMessageBox(strMsg);

	return 1;
}
