/**
 * @file  DFFileDeviceText.h
 * @brief Schnittstelle fuer die Klasse CDFFileDeviceText.
 */
//////////////////////////////////////////////////////////////////////
#ifndef _DFFILEDEVICETEXT_H_
#define _DFFILEDEVICETEXT_H_

#include "typedef.h"
#include "ErrorState.h"

// Basisklasse 
#include "DFFileIni.h"

class CDFFileDeviceText : public CDFFileIni
{
public:
	CDFFileDeviceText();
	virtual ~CDFFileDeviceText();

	void Reset();
	inline INT32 GetLastErrorState() { return m_errorState; };
	inline UINT32 GetSizeData() { return m_sizeData; };

	INT32 Load(INT8 *fileName);
	INT32 Save(INT8 *fileName, UINT8 append = FALSE);

protected:
	INT32 m_errorState;
	UINT32 m_sizeData;
};

#endif

